import json


# Argumentation for using a function like this. https://github.com/encode/django-rest-framework/issues/3070
def get_for_patch(instance, data, attr_name: str):
    attr = data.get(attr_name, None)
    if attr is None and instance:
        return getattr(instance, attr_name, None)
    return attr


def json_parse(json_str_obj):
    try:
        obj = json.loads(json_str_obj)
    except json.decoder.JSONDecodeError:
        obj = json.loads(json_str_obj.replace("'", '"').replace('False', 'false').replace('True', 'true'))
    except TypeError:
        obj = json_str_obj
    return obj
